; LoadBmpFromDisc demo by Vortex

.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\gdi32.inc
include     \masm32\include\masm32.inc

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\gdi32.lib
includelib  \masm32\lib\masm32.lib


WinMain             PROTO :DWORD,:DWORD,:DWORD,:DWORD
CreateBmpFromMem    PROTO :DWORD,:DWORD

.data
ClassName   db "BitmapClass",0
AppName     db "Bitmap from file",0
FileName    db 'logo.bmp',0

.data?
hInstance   HINSTANCE ?
hBitmap     dd ?
pMem        dd ?
ppvBits     dd ?

.code

start:

    invoke  GetModuleHandle, NULL
    mov     hInstance,eax
    invoke  GetCommandLine
    invoke  WinMain,hInstance,NULL,eax,SW_SHOWDEFAULT
    invoke  ExitProcess,eax

WinMain  PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

 LOCAL wc:WNDCLASSEX
 LOCAL msg:MSG
 LOCAL hwnd:HWND

    mov     wc.cbSize,SIZEOF WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    push    hInstance
    pop     wc.hInstance
    mov     wc.hbrBackground,COLOR_WINDOW+1
    mov     wc.lpszMenuName,NULL
    mov     wc.lpszClassName,OFFSET ClassName
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx, ADDR wc
    invoke  CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
            WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
            CW_USEDEFAULT,290,90,NULL,NULL,\
            hInst,NULL
    mov     hwnd,eax
    invoke  ShowWindow,hwnd,SW_SHOWNORMAL
    invoke  UpdateWindow,hwnd

.WHILE TRUE
    invoke  GetMessage, ADDR msg,NULL,0,0
    .BREAK  .if (!eax)
    invoke  TranslateMessage, ADDR msg
    invoke  DispatchMessage, ADDR msg
.ENDW

    mov     eax,msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

 LOCAL ps:PAINTSTRUCT
 LOCAL hdc:HDC
 LOCAL hMemDC:HDC
 LOCAL hFile:DWORD
 LOCAL FileSize:DWORD
 LOCAL bBytes:DWORD

    .IF uMsg==WM_CREATE

        invoke  CreateFile,ADDR FileName,GENERIC_READ,\
                0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
        mov     hFile,eax
        invoke  GetFileSize,eax,0
        mov     FileSize,eax
        invoke  VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
        mov     pMem,eax
        lea     ecx,bBytes
        invoke  ReadFile,hFile,eax,FileSize,ecx,0
        invoke  CloseHandle,hFile
        
        mov     eax,pMem
        add     eax,sizeof(BITMAPFILEHEADER)    ; start of BITMAPINFOHEADER header
        invoke  CreateDIBSection,0,eax,DIB_RGB_COLORS,ADDR ppvBits,0,0
        mov     hBitmap,eax
        mov     eax,pMem
        add     eax,sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)
        mov     ecx,FileSize
        sub     ecx,sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)
        invoke  MemCopy,eax,ppvBits,ecx         ; copy bitmap's bit values
          
    .ELSEIF uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,ADDR ps
        mov     hdc,eax
        invoke  CreateCompatibleDC,eax
        mov     hMemDC,eax
        invoke  SelectObject,eax,hBitmap
        mov     edx,pMem
        add     edx,sizeof(BITMAPFILEHEADER) ; start of the BITMAPINFOHEADER header
        invoke  BitBlt,hdc,0,0,BITMAPINFOHEADER.biWidth[edx],BITMAPINFOHEADER.biHeight[edx],hMemDC,0,0,SRCCOPY
        invoke  DeleteDC,hMemDC
        invoke  EndPaint,hWnd,ADDR ps

    .ELSEIF uMsg==WM_DESTROY
        invoke  DeleteObject,hBitmap
        invoke  VirtualFree,pMem,0,MEM_RELEASE
        invoke  PostQuitMessage,NULL

    .ELSE
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam  
        ret

    .ENDIF

    xor eax,eax
    ret

WndProc ENDP

END start
